Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.cs	(revision 17519)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.cs	(revision 17519)
@@ -0,0 +1,81 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public partial class JsonItemConcreteItemArrayControl : UserControl {
+    private StringArrayVM VM { get; set; }
+    private DataGridViewComboBoxColumn ComboBox { get; set; }
+    public JsonItemConcreteItemArrayControl(StringArrayVM vm) {
+      InitializeComponent();
+      dataGridView.AllowUserToDeleteRows = true;
+      VM = vm;
+      if (VM.Item.ConcreteRestrictedItems != null) {
+        ComboBox = new DataGridViewComboBoxColumn();
+        dataGridView.Columns.Add(ComboBox);
+        concreteItemsRestrictor.OnChecked += AddComboOption;
+        concreteItemsRestrictor.OnUnchecked += RemoveComboOption;
+        concreteItemsRestrictor.Init(VM.Item.ConcreteRestrictedItems);
+      } else {
+        dataGridView.AllowUserToAddRows = true;
+        dataGridView.Columns.Add(new DataGridViewTextBoxColumn());
+        groupBox2.Visible = false;
+        tableLayoutPanel1.RowStyles[0].SizeType = SizeType.Percent;
+        tableLayoutPanel1.RowStyles[0].Height = 100.0f;
+      }
+      if(VM.Value != null) {
+        foreach (var val in VM.Value) {
+          dataGridView.Rows.Add(val);
+        }
+      }
+    }
+
+    private void AddComboOption(object opt) {
+      ComboBox.Items.Add(opt);
+      IList<string> items = new List<string>();
+      foreach (var i in ComboBox.Items) {
+        items.Add((string)i);
+      }
+      VM.Range = items;
+      dataGridView.AllowUserToAddRows = true;
+    }
+
+    private void RemoveComboOption(object opt) {
+      ComboBox.Items.Remove(opt);
+      IList<string> items = new List<string>();
+      foreach (var i in ComboBox.Items) {
+        items.Add((string)i);
+      }
+      VM.Range = items;
+      
+      if (VM.Range.Count() <= 0) {
+        dataGridView.Rows.Clear();
+        dataGridView.AllowUserToAddRows = false;
+      }
+    }
+
+    private void BuildValue() {
+      IList<string> list = new List<string>();
+      for (int r = 0; r < dataGridView.Rows.Count; ++r) {
+        var value = dataGridView[0, r].Value;
+        if(value != null)
+          list.Add((string)value);
+      }
+      VM.Value = list.ToArray();
+    }
+    
+    private void dataGridView_RowsRemoved(object sender, DataGridViewRowsRemovedEventArgs e) {
+      BuildValue();
+    }
+
+    private void dataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e) {
+      BuildValue();
+    }
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs	(revision 17519)
@@ -80,5 +80,5 @@
       int cols = matrix.Length;
       int rows = matrix.Max(x => x.Length);
-
+      
       Matrix = matrix;
       Columns = cols;
@@ -250,5 +250,4 @@
                                             typeof(T),
                                             System.Globalization.CultureInfo.InvariantCulture);
-      //Save(Matrix[e.ColumnIndex][e.RowIndex], e.ColumnIndex, e.RowIndex);
       Save();
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs	(revision 17519)
@@ -25,8 +25,8 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      this.tableOptions = new System.Windows.Forms.TableLayoutPanel();
       this.comboBoxValues = new System.Windows.Forms.ComboBox();
       this.label2 = new System.Windows.Forms.Label();
       this.groupBoxRange = new System.Windows.Forms.GroupBox();
+      this.concreteItemsRestrictor = new HeuristicLab.JsonInterface.OptimizerIntegration.ConcreteItemsRestrictor();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
       this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
@@ -37,20 +37,4 @@
       this.tableLayoutPanel2.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // tableOptions
-      // 
-      this.tableOptions.AutoScroll = true;
-      this.tableOptions.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
-      this.tableOptions.ColumnCount = 2;
-      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
-      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableOptions.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableOptions.Location = new System.Drawing.Point(3, 16);
-      this.tableOptions.Name = "tableOptions";
-      this.tableOptions.RowCount = 1;
-      this.tableOptions.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableOptions.Size = new System.Drawing.Size(494, 217);
-      this.tableOptions.TabIndex = 12;
       // 
       // comboBoxValues
@@ -79,5 +63,5 @@
       // groupBoxRange
       // 
-      this.groupBoxRange.Controls.Add(this.tableOptions);
+      this.groupBoxRange.Controls.Add(this.concreteItemsRestrictor);
       this.groupBoxRange.Dock = System.Windows.Forms.DockStyle.Fill;
       this.groupBoxRange.Location = new System.Drawing.Point(0, 22);
@@ -88,4 +72,13 @@
       this.groupBoxRange.TabStop = false;
       this.groupBoxRange.Text = "Range";
+      // 
+      // concreteItemsRestrictor
+      // 
+      this.concreteItemsRestrictor.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.concreteItemsRestrictor.Location = new System.Drawing.Point(3, 16);
+      this.concreteItemsRestrictor.Margin = new System.Windows.Forms.Padding(0);
+      this.concreteItemsRestrictor.Name = "concreteItemsRestrictor";
+      this.concreteItemsRestrictor.Size = new System.Drawing.Size(494, 217);
+      this.concreteItemsRestrictor.TabIndex = 0;
       // 
       // errorProvider
@@ -122,5 +115,5 @@
       this.tableLayoutPanel2.RowCount = 1;
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
-      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 22F));
       this.tableLayoutPanel2.Size = new System.Drawing.Size(500, 22);
       this.tableLayoutPanel2.TabIndex = 19;
@@ -146,5 +139,4 @@
 
     #endregion
-    private System.Windows.Forms.TableLayoutPanel tableOptions;
     private System.Windows.Forms.ComboBox comboBoxValues;
     private System.Windows.Forms.Label label2;
@@ -153,4 +145,5 @@
     private System.Windows.Forms.TableLayoutPanel tableLayoutPanel2;
     private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+    private ConcreteItemsRestrictor concreteItemsRestrictor;
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs	(revision 17519)
@@ -1,10 +1,5 @@
-﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
+﻿using System.Collections.Generic;
 using System.Drawing;
-using System.Data;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
 using System.Windows.Forms;
 
@@ -18,44 +13,26 @@
       VM = vm;
       if (VM.Item.ConcreteRestrictedItems != null) {
-        foreach (var i in VM.Item.ConcreteRestrictedItems)
-          SetupOption(i);
+        concreteItemsRestrictor.OnChecked += AddComboOption;
+        concreteItemsRestrictor.OnUnchecked += RemoveComboOption;
+        concreteItemsRestrictor.Init(VM.Item.ConcreteRestrictedItems);
         comboBoxValues.DataBindings.Add("SelectedItem", VM, nameof(StringValueVM.Value));
       } else {
-        comboBoxValues.Hide();
         groupBoxRange.Hide();
         TextBox tb = new TextBox();
-        this.Controls.Add(tb);
+        tableLayoutPanel2.Controls.Remove(comboBoxValues);
+        tableLayoutPanel2.Controls.Add(tb, 1, 0);
+
         tb.Location = comboBoxValues.Location;
-        tb.Size = comboBoxValues.Size;
-        tb.Anchor = comboBoxValues.Anchor;
-        tb.Dock = comboBoxValues.Dock;
+        tb.Margin = new Padding(0);
+        tb.Size = new Size(comboBoxValues.Size.Width, 20);
+        tb.Anchor = AnchorStyles.Top | AnchorStyles.Left;
+        tb.Dock = DockStyle.Fill;
+
         tb.DataBindings.Add("Text", VM, nameof(StringValueVM.Value));
         tb.Show();
       }
     }
-    
-    private void SetupOption(string opt) {
-      AddComboOption(opt);
-      TextBox tb = new TextBox();
-      tb.Text = opt;
-      //tb.Size = new Size()
-      tb.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
-      //tb.Dock = DockStyle.Right | DockStyle.Left;
-      tb.ReadOnly = true;
 
-      CheckBox checkBox = new CheckBox();
-      checkBox.Checked = true;
-      
-      checkBox.CheckStateChanged += (o, args) => {
-        if (checkBox.Checked)
-          AddComboOption(opt);
-        else
-          RemoveComboOption(opt);
-      };
-      tableOptions.Controls.Add(checkBox);
-      tableOptions.Controls.Add(tb);
-    }
-
-    private void AddComboOption(string opt) {
+    private void AddComboOption(object opt) {
       comboBoxValues.Items.Add(opt);
       IList<string> items = new List<string>();
@@ -63,10 +40,9 @@
         items.Add((string)i);
       }
-      ((StringValueVM)VM).Range = items;
+      VM.Range = items;
       comboBoxValues.Enabled = true;
-      tableOptions.Refresh();
     }
 
-    private void RemoveComboOption(string opt) {
+    private void RemoveComboOption(object opt) {
       comboBoxValues.Items.Remove(opt);
       IList<string> items = new List<string>();
@@ -74,10 +50,9 @@
         items.Add((string)i);
       }
-      ((StringValueVM)VM).Range = items;
-      if (((StringValueVM)VM).Range.Count() <= 0) {
+      VM.Range = items;
+      if (VM.Range.Count() <= 0) {
         comboBoxValues.Enabled = false;
         comboBoxValues.SelectedIndex = -1;
       }
-      tableOptions.Refresh();
     }
   }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Constants.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Constants.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Constants.cs	(revision 17519)
@@ -1,9 +1,3 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-
-namespace HeuristicLab.JsonInterface {
+﻿namespace HeuristicLab.JsonInterface {
   /// <summary>
   /// Constants for reading/writing templates.
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs	(revision 17519)
@@ -8,38 +8,75 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Parameters;
 using Newtonsoft.Json.Linq;
 
 namespace HeuristicLab.JsonInterface {
   public class RegressionProblemDataConverter : BaseConverter {
+    #region Constants
     private const BindingFlags flags = BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance;
+    private const string TestPartition = "TestPartition";
+    private const string TrainingPartition = "TrainingPartition";
+    private const string TargetVariable = "TargetVariable";
+    private const string AllowedInputVariables = "AllowedInputVariables";
+    private const string Dataset = "Dataset";
+    private const string VariableValues = "variableValues";
+    private const string VariableNames = "variableNames";
+    private const string InputVariables = "InputVariables";
+    private const string Rows = "rows";
+    private const string Value = "value";
+    private const string Parameters = "parameters";
+    private const string CheckedItemList = "CheckedItemList";
+    #endregion
+
     public override int Priority => 20;
+
+    // RegressionProblemData
     public override Type ConvertableType => HEAL.Attic.Mapper.StaticCache.GetType(new Guid("EE612297-B1AF-42D2-BF21-AF9A2D42791C"));
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
-      var dictTmp = new Dictionary<string, IList>();
-      DoubleMatrixJsonItem matrix = data.Children[0] as DoubleMatrixJsonItem;
-      if(matrix != null) {
-        int c = 0;
-        foreach(var col in matrix.RowNames) {
-          dictTmp.Add(col, new List<double>(matrix.Value[c]));
-          ++c;
-        }
-      }
-
-      dynamic val = (dynamic)item;
-      object dataset = (object)val.Dataset;
-      var rows = dataset.GetType().GetField("rows", flags);
-      rows.SetValue(dataset, matrix.Value[0].Length);
-
-      var variableNames = dataset.GetType().GetField("variableNames", flags);
-      variableNames.SetValue(dataset, matrix.RowNames);
-
-      var dataInfo = dataset.GetType().GetField("variableValues", flags);
-      dataInfo.SetValue(dataset, dictTmp);
-      val.TargetVariable = ((StringJsonItem)data.Children[3]).Value;
-      val.TrainingPartition.Start = ((IntRangeJsonItem)data.Children[2]).MinValue;
-      val.TrainingPartition.End = ((IntRangeJsonItem)data.Children[2]).MaxValue;
-      val.TestPartition.Start = ((IntRangeJsonItem)data.Children[1]).MinValue;
-      val.TestPartition.End = ((IntRangeJsonItem)data.Children[1]).MaxValue;
+
+      dynamic regressionProblemData = (dynamic)item;
+
+      DoubleMatrixJsonItem dataset = null;
+      StringJsonItem targetVariable = null;
+      IntRangeJsonItem testPartition = null;
+      IntRangeJsonItem trainingPartition = null;
+      StringArrayJsonItem allowedInputVariables = null;
+
+
+      // search first for the items (cache them, because the 
+      // order is important for injection)
+      foreach (var child in data.Children) {
+
+        if (child.Path.EndsWith(Dataset))
+          dataset = child as DoubleMatrixJsonItem;
+        else if (child.Path.EndsWith(TargetVariable))
+          targetVariable = child as StringJsonItem;
+        else if (child.Path.EndsWith(TestPartition))
+          testPartition = child as IntRangeJsonItem;
+        else if (child.Path.EndsWith(TrainingPartition))
+          trainingPartition = child as IntRangeJsonItem;
+        else if (child.Path.EndsWith(AllowedInputVariables))
+          allowedInputVariables = child as StringArrayJsonItem;
+
+      }
+
+      // check data
+      if(!dataset.RowNames.Any(x => x == targetVariable.Value)) {
+        throw new Exception($"The value of the target variable ('{targetVariable.Value}') has no matching row name value of the dataset.");
+      }
+
+      foreach(var v in allowedInputVariables.Value) {
+        if(!dataset.RowNames.Any(x => x == v))
+          throw new Exception($"The value of the input variable ('{v}') has no matching row name value of the dataset.");
+      }
+
+      // inject the value of the items
+      SetDataset(regressionProblemData, dataset);
+      SetTargetVariable(regressionProblemData, targetVariable);
+      SetAllowedInputVariables(regressionProblemData, allowedInputVariables, dataset);
+      SetTestPartition(regressionProblemData, testPartition);
+      SetTrainingPartition(regressionProblemData, trainingPartition);
+
     }
 
@@ -50,72 +87,187 @@
       };
 
-      dynamic val = (dynamic)value;
+      IJsonItem ds = GetDataset(value);
+      if(ds != null)
+        item.AddChildren(ds);
+
+      item.AddChildren(GetTestPartition(value));
+      item.AddChildren(GetTrainingPartition(value));
+      item.AddChildren(GetTargetVariable(value));
+      item.AddChildren(GetAllowedInputVariables(value));
+      return item;
+    }
+
+    #region Inject Helper
+    private void SetDataset(dynamic regressionProblemData, DoubleMatrixJsonItem item) {
+      if (item != null) {
+        var dictTmp = new Dictionary<string, IList>();
+        int c = 0;
+        foreach (var col in item.RowNames) {
+          dictTmp.Add(col, new List<double>(item.Value[c]));
+          ++c;
+        }
+
+        object dataset = (object)regressionProblemData.Dataset;
+        var rows = dataset.GetType().GetField(Rows, flags);
+        rows.SetValue(dataset, item.Value[0].Length);
+
+        var variableNames = dataset.GetType().GetField(VariableNames, flags);
+        variableNames.SetValue(dataset, item.RowNames);
+
+        var dataInfo = dataset.GetType().GetField(VariableValues, flags);
+        dataInfo.SetValue(dataset, dictTmp);
+      }
+    }
+
+    private void SetTestPartition(dynamic regressionProblemData, IntRangeJsonItem item) {
+      if (item != null) {
+        regressionProblemData.TestPartition.Start = item.MinValue;
+        regressionProblemData.TestPartition.End = item.MaxValue;
+      }
+    }
+
+    private void SetTrainingPartition(dynamic regressionProblemData, IntRangeJsonItem item) {
+      if (item != null) {
+        regressionProblemData.TrainingPartition.Start = item.MinValue;
+        regressionProblemData.TrainingPartition.End = item.MaxValue;
+      }
+    }
+
+    private void SetTargetVariable(dynamic regressionProblemData, StringJsonItem item) {
+      if (item != null) {
+        var param = (IConstrainedValueParameter<StringValue>)regressionProblemData.TargetVariableParameter;
+        StringValue v = param.Value;
+        FieldInfo fi = v.GetType().GetField(Value, flags);
+        fi.SetValue(v, item.Value);
+      }
+    }
+
+    private void SetAllowedInputVariables(dynamic regressionProblemData, StringArrayJsonItem item, IMatrixJsonItem matrix) {
+      if (item != null && regressionProblemData is IParameterizedItem p) {
+        var regProbDataType = ((ParameterizedNamedItem)regressionProblemData).GetType(); //RegressionProblemData
+
+        var parameterizedNamedItemType = regProbDataType.BaseType.BaseType;
+
+        // reset parameter
+        var parametersInfo = parameterizedNamedItemType.GetField(Parameters, flags);
+        ParameterCollection col = (ParameterCollection)parametersInfo.GetValue((object)regressionProblemData);
+        var oldParam = (FixedValueParameter<ReadOnlyCheckedItemList<StringValue>>)col[InputVariables];
+        var value = oldParam.Value;
+        PropertyInfo listInfo = value.GetType().GetProperty(CheckedItemList, flags);
+        CheckedItemList<StringValue> checkedItemList = (CheckedItemList<StringValue>)listInfo.GetValue(value);
+        checkedItemList.Clear();
+
+        // add list items and set their check state (based on allowed input variables)
+        foreach(var i in matrix.RowNames) {
+          bool isChecked = false;
+          foreach(var x in item.Value)
+            isChecked = isChecked || (x == i);
+          checkedItemList.Add(new StringValue(i).AsReadOnly(), isChecked);
+        }
+      }
+    }
+    #endregion
+
+    #region Extract Helper
+    private IJsonItem GetDataset(IItem item) {
+      dynamic val = (dynamic)item;
       object dataset = (object)val.Dataset;
-      dynamic targetVariable = val.TargetVariable;
-      
-      FieldInfo dataInfo = dataset.GetType().GetField("variableValues", flags);
-      
-      if(dataInfo.GetValue(dataset) is Dictionary<string, IList> dict) {
-        int cols = dict.Count;
-        int rows = 0;
-        IList<string> rowNames = new List<string>();
-        double[][] mat = new double[cols][];
-        int c = 0;
-        foreach(var x in dict) {
-          rows = Math.Max(rows, x.Value.Count);
-          rowNames.Add(x.Key);
-          mat[c] = new double[rows];
-          int r = 0;
-          foreach(var rowValue in x.Value) {
-            // TODO: for integers and bools aswell
-            mat[c][r] = (double)rowValue; 
-            ++r;
+      FieldInfo dataInfo = dataset.GetType().GetField(VariableValues, flags);
+
+      if (dataInfo.GetValue(dataset) is Dictionary<string, IList> dict) {
+        IEnumerator it = dict.Values.First()?.GetEnumerator();
+
+        if(it != null) {
+          if(it.MoveNext() && it.Current is double) {
+            CreateMatrix(dict, out IList<string> rowNames, out double[][] mat);
+            return new DoubleMatrixJsonItem() {
+              Name = Dataset,
+              Value = mat,
+              RowNames = rowNames,
+              Minimum = double.MinValue,
+              Maximum = double.MaxValue
+            };
+          } else if(it.Current is int) {
+            CreateMatrix(dict, out IList<string> rowNames, out int[][] mat);
+            return new IntMatrixJsonItem() {
+              Name = Dataset,
+              Value = mat,
+              RowNames = rowNames,
+              Minimum = int.MinValue,
+              Maximum = int.MaxValue
+            };
+          } else if (it.Current is bool) {
+            CreateMatrix(dict, out IList<string> rowNames, out bool[][] mat);
+            return new BoolMatrixJsonItem() {
+              Name = Dataset,
+              Value = mat,
+              RowNames = rowNames
+            };
           }
-          ++c;
-        }
-        item.AddChildren(new DoubleMatrixJsonItem() {
-          Name = "Dataset",
-          Value = mat,
-          RowNames = rowNames,
-          Minimum = double.MinValue,
-          Maximum = double.MaxValue
-        });
-      }
-
-      var trainingPartition = ((IntRange)val.TrainingPartition);
-      var testPartition = ((IntRange)val.TestPartition);
-
-      item.AddChildren(new IntRangeJsonItem() {
-        Name = "TestPartition",
-        MinValue = testPartition.Start, 
+        }
+      }
+      return null;
+    }
+    
+    private void CreateMatrix<T>(Dictionary<string, IList> dict, out IList<string> rowNames, out T[][] matrix) {
+      int cols = dict.Count, rows = 0, c = 0;
+      rowNames = new List<string>();
+      matrix = new T[cols][];
+      foreach (var x in dict) {
+        rows = Math.Max(rows, x.Value.Count);
+        rowNames.Add(x.Key);
+
+        matrix[c] = new T[rows];
+        int r = 0;
+
+        foreach (var rowValue in x.Value) {
+          matrix[c][r] = (T)rowValue;
+          ++r;
+        }
+        ++c;
+      }
+    }
+
+    private IJsonItem GetTestPartition(IItem item) {
+      dynamic val = (dynamic)item;
+      var trainingPartition = (IntRange)val.TrainingPartition;
+      var testPartition = (IntRange)val.TestPartition;
+      return new IntRangeJsonItem() {
+        Name = TestPartition,
+        MinValue = testPartition.Start,
         MaxValue = testPartition.End,
-        Minimum = 0, 
+        Minimum = 0,
         Maximum = Math.Max(testPartition.End, trainingPartition.End)
-      });
-
-      
-      item.AddChildren(new IntRangeJsonItem() {
-        Name = "TrainingPartition",
+      };
+    }
+
+    private IJsonItem GetTrainingPartition(IItem item) {
+      dynamic val = (dynamic)item;
+      var trainingPartition = (IntRange)val.TrainingPartition;
+      var testPartition = (IntRange)val.TestPartition;
+      return new IntRangeJsonItem() {
+        Name = TrainingPartition,
         MinValue = trainingPartition.Start,
         MaxValue = trainingPartition.End,
         Minimum = 0,
         Maximum = Math.Max(testPartition.End, trainingPartition.End)
-      });
-
-      IEnumerable<StringValue> variables = (IEnumerable<StringValue>)val.InputVariables;
-      item.AddChildren(new StringJsonItem() {
-        Name = "TargetVariable",
-        Value = (string)targetVariable,
-        ConcreteRestrictedItems = variables.Select(x => x.Value)
-      });
-
-      /*
-      item.AddChildren(new StringArrayJsonItem() {
-        Name = "AllowedInputVariables",
-        Value = (string[])val.AllowedInputVariables,
-        Range = variables.Select(x => x.Value)
-      });*/
-      return item;
-    }
+      };
+    }
+      
+
+    private IJsonItem GetTargetVariable(IItem item) =>
+      new StringJsonItem() {
+        Name = TargetVariable,
+        Value = (string)((dynamic)item).TargetVariable,
+        //ConcreteRestrictedItems = variables.Select(x => x.Value)
+      };
+
+    private IJsonItem GetAllowedInputVariables(IItem item) =>
+      new StringArrayJsonItem() {
+        Name = AllowedInputVariables,
+        Value = ((IEnumerable<string>)((dynamic)item).AllowedInputVariables).ToArray(),
+        //ConcreteRestrictedItems = variables.Select(x => x.Value)
+      };
+    #endregion
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs	(revision 17519)
@@ -18,5 +18,5 @@
 
       if(parameter.ActualValue != null) {
-          if (data.Children == null || data.Children.Count == 0)
+          if (data.Children == null || data.Children.Count() == 0)
             root.Inject(parameter.ActualValue, data, root);
           else
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IArrayJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IArrayJsonItem.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IArrayJsonItem.cs	(revision 17519)
@@ -1,10 +1,8 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
+﻿namespace HeuristicLab.JsonInterface {
 
-namespace HeuristicLab.JsonInterface {
   public interface IArrayJsonItem : IValueJsonItem {
+    /// <summary>
+    /// Property to define an array item to be resizable.
+    /// </summary>
     bool Resizable { get; set; }
   }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IConcreteRestrictedJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IConcreteRestrictedJsonItem.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IConcreteRestrictedJsonItem.cs	(revision 17519)
@@ -1,10 +1,9 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
+﻿using System.Collections.Generic;
 
 namespace HeuristicLab.JsonInterface {
   public interface IConcreteRestrictedJsonItem<T> : IJsonItem {
+    /// <summary>
+    /// The item, 
+    /// </summary>
     IEnumerable<T> ConcreteRestrictedItems { get; set; }
   }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IIntervalRestrictedJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IIntervalRestrictedJsonItem.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Interfaces/IIntervalRestrictedJsonItem.cs	(revision 17519)
@@ -1,12 +1,18 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
 
 namespace HeuristicLab.JsonInterface {
+  /// <summary>
+  /// Interface to get a interval restrict JsonItems.
+  /// </summary>
+  /// <typeparam name="T"></typeparam>
   public interface IIntervalRestrictedJsonItem<T> : IJsonItem
     where T : IComparable {
+    /// <summary>
+    /// The allowed minimum of the JsonItem.
+    /// </summary>
     T Minimum { get; set; }
+    /// <summary>
+    /// The allowed maximum of the JsonItem.
+    /// </summary>
     T Maximum { get; set; }
   }
